/* a390.l */
/* Lexical Analyzer */

/*  
  Copyright (C) 1999, 2000 Dallas Semiconductor Corporation.
  All rights Reserved. Printed in U.S.A.
  This software is protected by copyright laws of
  the United States and of foreign countries.
  This material may also be protected by patent laws of the United States
  and of foreign countries.
  This software is furnished under a license agreement and/or a
  nondisclosure agreement and may only be used or copied in accordance
  with the terms of those agreements.
  The mere transfer of this software does not imply any licenses
  of trade secrets, proprietary technology, copyrights, patents,
  trademarks, maskwork rights, or any other form of intellectual
  property whatsoever. Dallas Semiconductor retains all ownership rights.
*/

/* BUILD INFORMATION:
     FLEX 2.5.4
     GCC 2.91.66 or MSDEVSTUDIO/VC 6 
 */

/* LIMITATIONS:
     - No linking supported.
     - No code in include files. The one exception is DB statements if the
       macro preprocessor "macro" is used to preprocess the input file.
     - Many more...
 */

/*
 $Workfile: a390.l $
 $Revision: 7 $
 $Date: 4/30/01 12:34p $
 $Author: Chenot $
 $Modtime: 4/30/01 12:34p $
 $Log: /TINI/390 Assembler/source/a390/a390.l $
* 
* 7     4/30/01 12:34p Chenot
* 
* 6     9/09/00 6:27p Chenot
* 
* 5     9/08/00 10:03a Chenot
* 
* 3     5/16/00 7:30a Chenot
* 
* 2     5/15/00 6:09a Chenot
* 
* 29    5/03/00 8:19a Chenot
* 
* 28    10/01/99 6:52a Tomc
* 
* 27    9/08/99 6:18a Tomc
* 
* 26    7/22/99 6:06a Tomc
* 
* 25    7/13/99 10:54a Tomc
* 
* 24    7/09/99 11:51a Tomc
* 
* 23    7/01/99 4:34p Tomc
* 
* 22    7/01/99 2:15p Tomc
* 
* 21    7/01/99 1:49p Tomc
* 
* 20    7/01/99 12:00p Tomc
* 
* 19    6/30/99 2:07p Tomc
* 
* 18    6/29/99 10:36a Tomc
* 
* 17    5/24/99 12:16p Tomc
* 
* 16    5/24/99 10:13a Tomc
* 
* 15    5/21/99 2:10p Tomc
* 
* 14    5/21/99 11:09a Tomc
* 
* 13    5/19/99 8:42a Tomc
* 
* 12    5/18/99 2:37p Tomc
* 
* 11    5/18/99 11:12a Tomc
* 
* 10    5/18/99 9:27a Tomc
* 
* 9     5/17/99 11:23a Tomc
* 
* 8     5/04/99 8:46a Tomc
* 
* 7     4/30/99 4:39p Tomc
* 
* 6     4/30/99 3:52p Tomc
* 
* 5     4/29/99 3:39p Tomc
* 
* 4     4/29/99 11:06a Tomc
* Added Intel Extended Hex Output
* 
* 3     4/28/99 1:37p Tomc
* 
* 2     4/28/99 11:07a Tomc
* 
* 1     4/27/99 3:32p Tomc
*/

/*  Definitions and C pass-throughs  */

%{
#ifdef WIN32
#ifdef FLEX_SCANNER
#undef YY_DO_BEFORE_ACTION
#define YY_DO_BEFORE_ACTION \
  yytext_ptr = yy_bp; \
  yyleng = (int) (yy_cp - yy_bp); \
  yy_hold_char = *yy_cp; \
  *yy_cp = '\0'; \
  yy_c_buf_p = yy_cp;\
  g_lpTempByte = yy_bp;\
  oldpplineno = pplineno; \
  while(g_lpTempByte < yy_cp) \
  { \
    if(*g_lpTempByte == 10) /* NewLine */ \
    {\
      pplineno++; \
    }\
    g_lpTempByte++; \
  }
#undef unput
#define unput(c)  yyunput( c, yytext_ptr );\
                  if(c == 10)\
                    pplineno--;
#undef yyless
#define yyless(n) \
  do \
    { \
    /* Undo effects of setting up yytext. */ \
    *yy_cp = yy_hold_char; \
    YY_RESTORE_YY_MORE_OFFSET \
    yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
    pplineno = oldpplineno; \
    YY_DO_BEFORE_ACTION; /* set up yytext again */ \
    } \
  while ( 0 )

int   pplineno    = 1,
      oldpplineno = 1;
char  *g_lpTempByte;

#endif/* FLEX_SCANNER */ 
#endif /* WIN32 */
#undef YY_MAIN
/***************************************************************************/
/************************* begin my lex declarations ***********************/

#include "a390.h"

extern int   yyerror (char *mesg);
extern char  *g_FileName;
extern union ystack yylval;
extern int   pass;
extern int   dashl;
extern char  g_StatsOn;
extern char  g_AllowDirectOverlap;
extern MODULE_STATS g_ModuleStats;

struct  symbol *looksym();
struct  opcode *lookop();
char *malloc();
int ResolveNumber(char *p_NumberString);

int  StrCmp(char *p_S1, char *p_S2);

char  *g_lpLineBuff;
char  g_LineBuff[256] = 
{
  0x00,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55
};

char  g_TempBuff[256] = 
{
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,
  0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55
};

char  *g_yyCur;
int   g_Value       = 0;
char  g_TempChar    = 0;
int   lineno        = 0;
int   g_InComment   = 0;
int   g_DebugOutput = 0;
char  *g_lpTempPtr;
int   g_NumberToResolve;
int   g_Index;
char  g_CurrentIdentifier[256] = {0};
char  g_TempString[260];

#define   C_SEG   0
#define   D_SEG   1
#define   X_SEG   2
#define   I_SEG   3
#define   B_SEG   4

unsigned  long  g_SegmentOrg[5] = {0,0,0,0,0};
int             g_CurrSegType   = C_SEG;
char            g_ReservedData[128];

#define S_INITIAL INITIAL
                              
/************************* end my lex declarations *************************/
/***************************************************************************/
%}

HexNumberOld       ("0"[a-fA-F]([a-fA-F]|[0-9])+[Hh])|([0-9]([a-fA-F]|[0-9])*[Hh])
HexNumber         [0-9]+([0-9]|[a-fA-F])*[Hh]
DecNumber         [0-9]+[Dd]{0,1}
BinNumber         [0-1]+[Bb]
Number            {HexNumber}|{DecNumber}|{BinNumber}
Char              \'[^\']\'
String            (\"[^\"]+\")|(\'[^\']+\')
WhiteSpace        [ \t]
Macro             [Mm][Aa][Cc][Rr][Oo]
EndMacro          [Ee][Nn][Dd][Mm]
Param             [Pp][Aa][Rr][Aa][Mm]
Local             [Ll][Oo][Cc][Aa][Ll]
Separator         {WhiteSpace}+
Shr               {Separator}[Ss][Hh][Rr]{Separator}
Shl               {Separator}[Ss][Hh][Ll]{Separator}
And               {Separator}[Aa][Nn][Dd]{Separator}
Or                {Separator}[Oo][Rr]{Separator}
Logical           {Shr}|{Shl}|{And}|{Or}
Extern            [Ee][Xx][Tt][Rr][Nn]
Public            [Pp][Uu][Bb][Ll][Ii][Cc]
Org               [Oo][Rr][Gg]
End               [Ee][Nn][Dd]
At                [Aa][Tt]
DB                [Dd][Bb]
DW                [Dd][Ww]
DT                [Dd][Tt]
MultiStorage      ({DB}|{DW}|{DT}){Separator}+
DS                [Dd][Ss]
DBit              [Dd][Bb][Ii][Tt]
UnitStorage       ({DS}|{DBit}){Separator}+{Number}
BitStorage        {Identifier}{Separator}+{Bit}{Separator}+{Identifier}{BitDigit}
Segment           [Ss][Ee][Gg][Mm][Ee][Nn][Tt]
Bit               [Bb][Ii][Tt]
Code              [Cc][Oo][Dd][Ee]
Data              [Dd][Aa][Tt][Aa]
IData             [Ii][Dd][Aa][Tt][Aa]
XData             [Xx][Dd][Aa][Tt][Aa]
SegType           ({Bit}|{Code}|{Data}|{IData}|{XData})
RSeg              [Rr][Ss][Ee][Gg]
CSeg              [Cc][Ss][Ee][Gg]
DSeg              [Dd][Ss][Ee][Gg]
XSeg              [Xx][Ss][Ee][Gg]
ISeg              [Ii][Ss][Ee][Gg]
BSeg              [Bb][Ss][Ee][Gg]
SegSelect         {CSeg}|{DSeg}|{XSeg}|{ISeg}|{BSeg}
SegSelectAt       {SegSelect}{Separator}+{At}{Separator}+{Number}
Name              [Nn][Aa][Mm][Ee]
High              [Hh][Ii][Gg][Hh]
Low               [Ll][Oo][Ww]
Not               [Nn][Oo][Tt]
Arithmetic        "+"|"-"|"*"|"/"
Operator          {Arithmetic}|{Logical}
Letter            [a-zA-Z_?]
SpecialChars      [$]
Digit             [0-9]
BitDigit          "."[0-7]
Equate            [Ee][Qq][Uu]
ValidIdChars      ({Letter}|{Digit})
Identifier        {Letter}{ValidIdChars}*
EquStatement      {Identifier}
Label             ^{Identifier}":"
SegmentDeclaration {Identifier}{Separator}+{Segment}{Separator}+{SegType}
ValidFileNameChars {Identifier}|"~"|"-" 
FileName          {ValidFileNameChars}+("."{ValidFileNameChars})*
Directory         ({Letter}":"){0,1}((("."){1,2})|{FileName})*("\\"|"/")
Include           ^"$"[Ii][Nn][Cc][Ll][Uu][Dd][Ee]{WhiteSpace}*"("{WhiteSpace}*{Directory}*{FileName}{WhiteSpace}*")"
BeginModule       ^"$BEGIN_MODULE"("("{FileName}")").*
EndModule         ^"$END_MODULE".*
Comma             ","
Debug             ^";!DEBUG!"
Comment           ";".*
Expression        (({Number}|{Identifier}){Operator})*({Number}|{Identifier})
ExpressionEx      {Expression}|("("{Expression}")")
DollarAddr        "$"({Arithmetic}{ExpressionEx})*
MultiExpression   {ExpressionEx}
HashMark          "#"
Immediate         {HashMark}{MultiExpression}
Indirect          "@"{Identifier}({Arithmetic}{ExpressionEx})*
NewLine           "\n"|"\r\n"
CommentNewLine    {Comment}{0,1}{NewLine}
Control           ^"$".*
Directive         ^({Extern}|{Public}).*
PassThrough       {Directive}|{Control}
Other             .

%%
{BeginModule}     { /* BEGIN_MODULE*/
                    if(!pass1 && 
                       dashl && 
                       (g_ModuleStats.count < MAX_MODULE_STATS))
                    {
                      memset(&g_ModuleStats.modules[g_ModuleStats.count], 0, sizeof(MODULE_STRUCT));
                      strcpy(g_TempBuff, yytext);
                      strtok(g_TempBuff,"()");
                      strcpy(g_ModuleStats.modules[g_ModuleStats.count].name, strtok(NULL,"()"));
                      //printf("BEGIN_MODULE %s *********************\n", g_ModuleStats.modules[g_ModuleStats.count].name);
                    }
                  }
{EndModule}       { /* END_MODULE*/
                    if(!pass1 && 
                       dashl &&
                       (g_ModuleStats.count < MAX_MODULE_STATS))

                    {
                      //printf("END_MODULE %s *********************\n",g_ModuleStats.modules[g_ModuleStats.count].name);
                      g_ModuleStats.count++;
                    }
                  }

{Debug}           { /* DEBUG */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    g_DebugOutput = !g_DebugOutput;

                    if(g_DebugOutput)
                      printf("Debug ");
                  }

{Char}            {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("Char[%s] ", yytext);

                    yylval.value = yytext[1];
                    return(VALUE);
                  }

{String}          {
                    /* strip the quotes */                                  
                    strcpy(g_TempBuff, yytext+1);
                    g_TempBuff[strlen(g_TempBuff) - 1] = 0;
                                                                                
                    if(!pass1 && dashl)                                                  
                      strcat(g_LineBuff, yytext);                               
                                                              
                    if(pass1)                                                   
                      yylval.value = strlen(g_TempBuff);                            
                    else                                                        
                    {                                                           
                      if((yylval.str = malloc(strlen(g_TempBuff) + 1)) == NULL)     
                        yyerror("Memory Allocation Error.");                    
                      else                                                      
                      {                                                         
                        strcpy(yylval.str, g_TempBuff);                                                   
                      }                                                         
                    }                                                           
                                                              
                    return(STRING);                                             
                  }

"."[0-7]          {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("DotNum[%s] ", yytext);

                    yylval.value = yytext[1] - '0';
                    return(BITPOS);
                  }

{HexNumber}       {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("HexNumber[%s] ", yytext);
                    
                    g_yyCur = yytext;
                    g_Value = 0;

                    while((g_TempChar = toupper(*g_yyCur++)) != 'H')
                    {
                      g_Value <<= 4;

                      if((g_TempChar <= 'F') && (g_TempChar >= 'A'))
                        g_Value += (g_TempChar - 'A' + 0x0A);
                      else
                        g_Value += (g_TempChar - '0');
                    }
                    
                    yylval.value = g_Value;
                    return(VALUE);                    
                  }

{DecNumber}       {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("DecNumber[%s] ", yytext);
                    
                    g_yyCur = yytext;
                    g_Value = 0;

                    while(*g_yyCur && (g_TempChar = toupper(*g_yyCur++)) != 'D')
                    {
                      g_Value *= 10;
                      g_Value += (g_TempChar - '0');
                    }
                    
                    yylval.value = g_Value;
                    return(VALUE);                    
                  }

{BinNumber}       {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("BinNumber[%s] ", yytext);
                    
                    g_yyCur = yytext;
                    g_Value = 0;

                    while(*g_yyCur && (g_TempChar = toupper(*g_yyCur++)) != 'B')
                    {
                      g_Value <<= 1;
                      g_Value += (g_TempChar - '0');
                    }
                    
                    yylval.value = g_Value;
                    return(VALUE);                    
                  }

{Include}         {  /* Include */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("Include[%s] ", yytext);
                  }

{UnitStorage}     { /* UnitStorage */ 
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    /* NEEDS WORK ??? Might be fine now */
                    if(g_DebugOutput)
                      printf("UnitStorage[%s] ",yytext);
                    
                    if(pass1)
                    {
                      g_lpTempPtr = yytext;
                      while(!isspace(*g_lpTempPtr++)); /* move past DS      */
                      while(isspace(*g_lpTempPtr++));  /* move to NUMBER    */
                      g_lpTempPtr--;

                      g_NumberToResolve = ResolveNumber(g_lpTempPtr);

                      switch(toupper(yytext[1]))
                      {
                        case 'S':
                          for(g_Index = 0; g_Index < g_NumberToResolve; g_Index++)
                          {
if(!g_AllowDirectOverlap)
                            if(g_ReservedData[g_SegmentOrg[D_SEG]])
                              yyerror("Overlap detected in Direct Segment");

                            g_ReservedData[g_SegmentOrg[D_SEG]++] = 1;
                          }
                        break;

                        default:
                        break;
                      }
                    }
                  }

{Label}{Separator}*{UnitStorage} { /* UnitStorage */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    /* NEEDS WORK ??? Might be fine now */
                    if(g_DebugOutput)
                      printf("UnitStorage[%s] ",yytext);

                    if(pass1)
                    {
                      g_lpTempPtr = yytext;
                      while(!isspace(*g_lpTempPtr++)); /* move past Label   */

                      strcpy(g_TempString, yytext);                    
                      g_TempString[g_lpTempPtr - yytext - 2] = 0;

                      yylval.sym = looksym(g_TempString);
                      yylval.sym->type  = LABEL;

                      while(isspace(*g_lpTempPtr++));  /* move to DS        */
                      strcpy(g_CurrentIdentifier, g_lpTempPtr);                    

                      while(!isspace(*g_lpTempPtr++)); /* move past DS      */
                      while(isspace(*g_lpTempPtr++));  /* move to NUMBER    */
                    
                      g_lpTempPtr--;
                      g_NumberToResolve = ResolveNumber(g_lpTempPtr);

                      switch(toupper(*g_CurrentIdentifier))
                      {
                        case 'S':
                          yylval.sym->value = g_SegmentOrg[D_SEG];
                         
                          for(g_Index = 0; g_Index < g_NumberToResolve; g_Index++)
                          {
if(!g_AllowDirectOverlap)
                            if(g_ReservedData[g_SegmentOrg[D_SEG]])
                              yyerror("Overlap detected in Direct Segment");

                            g_ReservedData[g_SegmentOrg[D_SEG]++] = 1;
                          }
                        break;

                        default:
                        break;
                      }
                    }
                  }

{BitStorage}      { /* BitStorage */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    /* NEEDS WORK ??? Might be fine now */
                    if(g_DebugOutput)
                      printf("UnitStorage[%s] ",yytext);

                    if(pass1)
                    {
                      g_lpTempPtr = yytext;
                    
                      strcpy(g_TempString, yytext);                    
                      while(!isspace(*g_lpTempPtr++)); /* move past Identifier */
                      g_TempString[g_lpTempPtr - yytext - 1] = 0;

                      yylval.sym  = looksym(g_TempString);

                      while(isspace(*g_lpTempPtr++));  /* move to BIT          */
                      while(!isspace(*g_lpTempPtr++)); /* move past BIT        */
                      while(isspace(*g_lpTempPtr++));  /* move to Idendifier   */
                      g_lpTempPtr--;

                      strcpy(g_CurrentIdentifier, g_lpTempPtr);

                      g_Index = 0;

                      while(g_CurrentIdentifier[g_Index] != '.')
                        g_Index++;
                    
                      g_CurrentIdentifier[g_Index] = 0;

                      yylval.sym->value  = looksym(g_CurrentIdentifier)->value;
                      yylval.sym->type  = LABEL;

                      /* now we need to get the bit address from the byte address */
                      if(yylval.sym->value < 0x80)
                      { /* this is in scratch pad land */
                        if((yylval.sym->value < 0x20) || (yylval.sym->value > 0x2F))
                          yyerror("Invalid bit address");

                        yylval.sym->value = (yylval.sym->value - 0x20) * 8 + (g_CurrentIdentifier[g_Index+1] - '0');
                      }
                      else
                      { /* this is in SFR land */
                        if((yylval.sym->value % 8))
                          yyerror("Invalid bit address");

                        yylval.sym->value = yylval.sym->value + (g_CurrentIdentifier[g_Index+1] - '0');
                      }
                    }
                  }

{Directive}       { /* Directive */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("Directive[%s] ", yytext);
                  }

{SegmentDeclaration} {

                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("SegmentDeclaration ");
                  }

{SegSelectAt}     { /* SegSelectAt */ 
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("SegSelectAt[%s] ",yytext);
                    
                    g_lpTempPtr = yytext;
                    
                    while(!isspace(*g_lpTempPtr++)); /* move past segtype */
                    while(isspace(*g_lpTempPtr++));  /* move to AT        */
                    g_lpTempPtr--;

                    switch(toupper(*yytext))
                    {
                      case 'C':
                        g_CurrSegType = C_SEG;
                      break;

                      case 'D':
                        g_CurrSegType = D_SEG;
                      break;

                      case 'X':
                        g_CurrSegType = X_SEG;
                      break;

                      case 'I':
                        g_CurrSegType = I_SEG;
                      break;

                      case 'B':
                        g_CurrSegType = B_SEG;
                      break;
                    }

                    while(!isspace(*g_lpTempPtr++)); /* move past AT      */
                    while(isspace(*g_lpTempPtr++));  /* move to NUMBER    */
                    g_lpTempPtr--;

                    g_SegmentOrg[g_CurrSegType] = ResolveNumber(g_lpTempPtr);
                  }

{Segment}         { /* Segment */  
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("Segment ");

                    return SEGMENT;
                  }

{SegType}         { /* SegType */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("SegmentType[%s] ", yytext);

                    return SEGMENT_TYPE;
                  }

{SegSelect}       { /* SegSelect */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("SegSelect[%s] ", yytext);
                  }

{DB}              {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("DB[%s] ", yytext);

                    return D_BYTE;
                  }

{DW}              {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("DW[%s] ", yytext);

                    return D_WORD;
                  }

{DT}              {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("DT[%s] ", yytext);

                    return D_TRIPLE;
                  }

{At}              { /* At */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("At ");
                  }

{RSeg}.*          { /* RSeg */ /* hack to ignore line for now */ 
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("RSeg ");

                  }

{Org}             { /* Org */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("Org ");

                    return D_ORG;
                  }

{Name}{WhiteSpace}.* { /* Name */ 
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("Name[%s] ", yytext);

                  }

{End}             {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("End[%s] ", yytext);
                    
/*
                    if(yylval.op = lookop(yytext)) 
                      return(yylval.op->type);

                    yylval.sym = looksym(yytext);
                    return(SYMBOL);
*/
                    return D_END;
                  }

{Identifier}      {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("Identifier[%s] ", yytext);
                    
                    strcpy(g_CurrentIdentifier, yytext);
                    strcpy(g_TempBuff,  yytext);
                    
                    if(!StrCmp(g_TempBuff, "CALL"))
                      strcpy(g_TempBuff, "LCALL");

                    if((yylval.op = lookop(g_TempBuff)))
                      return(yylval.op->type);

                    yylval.sym = looksym(g_TempBuff);

                    if(!yylval.sym)
                      yylval.sym  = g_TempBuff;

                    return(SYMBOL);
                  }

{Separator}       {
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf(".");                    
                  }

{CommentNewLine}  { /* newline */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("[Line %06d] %s",  lineno,  yytext);

                    if(!pass1)
                    {
                      yylval.str = g_LineBuff;
                    }

                    lineno++;
                    return('\n');
                  }

"$"               { /* Dollar  */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("Dollar[%s] ", yytext);
                    
                    return *yytext;
                  }

{Other}           { /* Other  */
                    if(!pass1 && dashl)
                      strcat(g_LineBuff, yytext);

                    if(g_DebugOutput)
                      printf("Other[%s] ", yytext);
                    
                    return *yytext;
                  }

%%
/*  Program Section  */ 
/***************************************************************************/
/***************************************************************************/
void  ResetLineBuffer()
{
  *g_LineBuff = 0;
}
/***************************************************************************/
int ResolveNumber(char *p_NumberString)
{
  char  l_TempChar;
  char  *l_lpTempPtr  = p_NumberString;
  int   l_Value       = 0;

  switch(toupper(l_lpTempPtr[strlen(l_lpTempPtr)-1]))
  {
    case 'H':
      while((l_TempChar = toupper(*l_lpTempPtr++)) != 'H')
      {
        l_Value <<= 4;

        if((l_TempChar <= 'F') && (l_TempChar >= 'A'))
          l_Value += (l_TempChar - 'A' + 0x0A);
        else
          l_Value += (l_TempChar - '0');
      }
    break;

    case 'B':
      while(*l_lpTempPtr && (l_TempChar = toupper(*l_lpTempPtr++)) != 'D')
      {
        l_Value <<= 1;
        l_Value += (l_TempChar - '0');
      }
    break;

    case 'D':
    default:
      while(*l_lpTempPtr && (l_TempChar = toupper(*l_lpTempPtr++)) != 'D')
      {
        l_Value *= 10;
        l_Value += (l_TempChar - '0');
      }
    break;
  }

  return l_Value;
}
/***************************************************************************/
int  StrCmp(char *p_S1, char *p_S2)
{
  int l_i,
      l_Length = strlen(p_S1) > strlen(p_S2)? strlen(p_S1): strlen(p_S2),
      l_Difference;

  
  for(l_i = 0;  l_i < l_Length; l_i++)  
  {
    if((l_Difference = toupper(p_S1[l_i]) - toupper(p_S2[l_i])))
      break;
  }

  return l_Difference;
}
/***************************************************************************/
/****************************** end my lex source **************************/
/***************************************************************************/
