
/*---------------------------------------------------------------------------
 * Copyright (C) 1999,2000 Dallas Semiconductor Corporation, All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL DALLAS SEMICONDUCTOR BE LIABLE FOR ANY CLAIM, DAMAGES
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name of Dallas Semiconductor
 * shall not be used except as stated in the Dallas Semiconductor
 * Branding Policy.
 *---------------------------------------------------------------------------
 */

package com.dalsemi.protocol;



//this is ready to move into the java.net package upon upgrade to java 1.2
public class URLDecoder
{

   /**
    * Method decode
    * this method takes an encoded url like
    * "this+is+a+test+%42%42"
    *
    * and turns it into
    * "this is a test **"
    *
    * @param s
    *
    * @return
    *
    */
   public static String decode (String s)
   {
      byte[] b     = s.getBytes();
      int    index = 0;
      int    x, x1;

      for (int i = 0; i < b.length; i++)
      {
         if (b [i] == '%')
         {
            //then we must decode the next two hex digits
            i++;

            //this mask takes away all higher bits, except one
            //bit that will tell us if the byte is alphanumeric
            x = (b [i] & 0x4f);

            //if it is aphanumeric then adjust it so 'f' maps to 0x0f
            if (x > 0x0f)
               x += 9;

            i++;

            x1 = (b [i] & 0x4f);

            //here we adjust differently since we will not be shifting this one
            if (x1 > 0x0f)
               x1 -= 55;

            b [index] = ( byte ) (x1 | (x << 4));
         }
         else
         {
            //if it is a plus, replace with a space,
            //else just copy the character
            b[index] = (b[i]=='+') ? 0x20 : b[i];
         }

         index++;
      }

      return new String(b, 0, index);
   }
}
