/****************************************************************************
*
*  Copyright (C) 1999,2000 Dallas Semiconductor Corporation. 
*  All rights Reserved. Printed in U.S.A.
*  This software is protected by copyright laws of
*  the United States and of foreign countries.
*  This material may also be protected by patent laws of the United States 
*  and of foreign countries.
*  This software is furnished under a license agreement and/or a
*  nondisclosure agreement and may only be used or copied in accordance
*  with the terms of those agreements.
*  The mere transfer of this software does not imply any licenses
*  of trade secrets, proprietary technology, copyrights, patents,
*  trademarks, maskwork rights, or any other form of intellectual
*  property whatsoever. Dallas Semiconductor retains all ownership rights.
*
*     Module Name: SledInputStream.java
*/
package com.dalsemi.slush.command.sled;

import java.io.*;
import com.dalsemi.shell.server.*;

/**
 * An InputStream for general Sled use.  It is used primarily
 * as a temporary workaround to non-tab support in Sled.
 *
 * @author  Stephen Hess
 * @version 1.0
 */
public class SledInputStream extends SystemInputStream
{
    public SledInputStream(InputStream root, PrintStream out)
    {
        super(root, out);
        rawMode = true;
    }
    
    public String readLine()
    {
        return null;
    }

    public int rawRead() throws IOException
    {
        char newVal = (char)root.read();
        
        //DEBUG ==>Tab hack, don't echo back the tab
        //character.  See the todo list for more info.
        if (ECHO)
        {
            if (newVal == 0x7F)
                out.write(ERASE);
            else if ((newVal != 0x1b) && (newVal != '\t'))
            {
                out.write(newVal);
            }
            out.flush();
        }
        	        
        return newVal;
    }
}