/*
 $Workfile: macro.h $
 $Revision: 6 $
 $Date: 2/06/02 6:34a $
 $Author: Chenot $
 $Modtime: 2/06/02 6:10a $
 $Log: /TINI/390 Assembler/source/macro/macro.h $
* 
* 6     2/06/02 6:34a Chenot
* 
* 5     2/06/02 5:51a Chenot
* initial support for *nested* conditional blocks
* 
* 4     11/01/01 2:20p Chenot
* 
* 3     2/17/01 5:27p Chenot
* 
* 2     5/15/00 6:11a Chenot
* 
* 12    1/06/00 7:27a Tomc
* 
* 11    1/05/00 3:53p Tomc
* 
* 10    5/20/99 11:49a Tomc
* 
* 9     4/21/99 3:24p Tomc
* 
* 8     4/21/99 2:28p Tomc
* 
* 7     4/20/99 3:46p Tomc
* 
* 6     4/20/99 8:07a Tomc
* 
* 5     4/19/99 10:23a Tomc
* 
* 4     4/16/99 3:08p Tomc
* 
* 3     4/15/99 3:40p Tomc
* 
* 2     4/15/99 5:24a Tomc
* 
* 1     4/14/99 8:41a Tomc
*/

#ifndef _MACRO_H_
#define _MACRO_H_

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <ctype.h>

#ifndef TOKEN_IDENTIFIER
#define USER_VAR                  257
#define TOKEN_IDENTIFIER          USER_VAR+0
#define TOKEN_MACRO               USER_VAR+1
#define TOKEN_ENDMACRO            USER_VAR+2
#define TOKEN_IMMEDIATE           USER_VAR+3
#define TOKEN_PARAM               USER_VAR+4
#define TOKEN_NEWLINE             USER_VAR+5
#define TOKEN_COMMA               USER_VAR+6
#define TOKEN_INCLUDE             USER_VAR+7
#define TOKEN_NUMBER              USER_VAR+8
#define TOKEN_EQUATE              USER_VAR+9
#define TOKEN_DOLLAR              USER_VAR+10
#define TOKEN_DOLLAR_EX           USER_VAR+11
#define TOKEN_INDIRECT            USER_VAR+12
#define TOKEN_CODE                USER_VAR+13
#define TOKEN_LOCAL               USER_VAR+14
#define TOKEN_END                 USER_VAR+15
#define TOKEN_AND                 USER_VAR+16
#define TOKEN_OR                  USER_VAR+17
#define TOKEN_SHL                 USER_VAR+18
#define TOKEN_SHR                 USER_VAR+19
#define TOKEN_HIGH                USER_VAR+20
#define TOKEN_LOW                 USER_VAR+21
#define TOKEN_NOT                 USER_VAR+22
#define TOKEN_SEGMENT             USER_VAR+23
#define TOKEN_SEGMENT_TYPE        USER_VAR+24
#define TOKEN_SEGMENT_SELECT      USER_VAR+25
#define TOKEN_AT                  USER_VAR+26
#define TOKEN_RSEG                USER_VAR+27
#define TOKEN_ORG                 USER_VAR+28
#define TOKEN_BIT                 USER_VAR+29
#define TOKEN_IF                  USER_VAR+30
#define TOKEN_ELSE                USER_VAR+31
#define TOKEN_ENDIF               USER_VAR+32
#define TOKEN_MIN                 USER_VAR+33
#define TOKEN_MAX                 USER_VAR+34


#endif//TOKEN_IDENTIFIER


#ifdef WIN32
#define BOOL int
#endif

#ifndef TRUE
#define TRUE  1
#define FALSE 0
#endif

#define MAX_INCLUDE     100
#define MAX_CONDITIONAL 100

#ifdef WIN32
typedef unsigned char   uchar;
typedef unsigned short  ushort;
#define DIRECTORY_SEPARATOR "\\"
#else
typedef int BOOL;
#define DIRECTORY_SEPARATOR "/"
#endif

typedef struct _INCLUDE_FILE
{
  char  FileName[260];
  FILE  *FilePointer;
  long   LineNumber;
  struct yy_buffer_state *BufferState;
} INCLUDE_FILE, *LPINCLUDE_FILE;

typedef struct _INCLUDE_TABLE
{
  int StackPointer;
  INCLUDE_FILE List[MAX_INCLUDE];
} INCLUDE_TABLE, *LPINCLUDE_TABLE;


typedef struct _CONDITIONAL
{
  char FileName[260];
  char InExclusion;
  long LineNumber;
} CONDITIONAL, *LPCONDITIONAL;

typedef struct _CONDITIONAL_TABLE
{
  int StackPointer;
  CONDITIONAL List[MAX_CONDITIONAL];
} CONDITIONAL_TABLE, *LPCONDITIONAL_TABLE;

#define REFERENCE_TEXT  0
#define REFERENCE_PARAM 1
#define REFERENCE_LOCAL 2
#define REFERENCE_MACRO 3

typedef struct _REFERENCE
{
  int   Type;
  int   Index;
  void  *Pointer;
} REFERENCE, *LPREFERENCE;

typedef struct _REFERENCE_LIST
{
  REFERENCE               Reference;
  struct _REFERENCE_LIST  *Next;
} REFERENCE_LIST, *LPREFERENCE_LIST;

typedef struct _MACRO
{
  char              *Name;
  char              *Params;
  char              *Locals;
  char              *Body;
  int               ParamCount;
  int               ParamInstances;
  int               LocalCount;
  int               LocalInstances;
  int               MacroCount;
  int               MacroInstances;
  int               PointerCount;
  LPREFERENCE_LIST  References;
} MACRO,  *LPMACRO;

typedef struct _MACRO_LIST
{
  MACRO Macro;
  struct _MACRO_LIST *Next;
} MACRO_LIST, *LPMACRO_LIST;

#define EQUATE_VALUE      0
#define EQUATE_REFERENCE  1

typedef struct _EQUATE
{
  char  *Name;
  int   Type;
  int   Value;
  char  *Reference;
} EQUATE,*LPEQUATE;

typedef struct _EQUATE_LIST
{
  EQUATE  Equate;
  struct _EQUATE_LIST *Next;
} EQUATE_LIST,*LPEQUATE_LIST;

//#undef YY_BUF_SIZE
//#define YY_BUF_SIZE 65536
#endif/*_MACRO_H_*/
