/* Macro.y */
/* Syntax Analyzer */

/*
  Copyright (C) 1999, 2000 Dallas Semiconductor Corporation.
  All rights Reserved. Printed in U.S.A.
  This software is protected by copyright laws of
  the United States and of foreign countries.
  This material may also be protected by patent laws of the United States
  and of foreign countries.
  This software is furnished under a license agreement and/or a
  nondisclosure agreement and may only be used or copied in accordance
  with the terms of those agreements.
  The mere transfer of this software does not imply any licenses
  of trade secrets, proprietary technology, copyrights, patents,
  trademarks, maskwork rights, or any other form of intellectual
  property whatsoever. Dallas Semiconductor retains all ownership rights.
*/

/* BUILD INFORMATION:
     BISON 1.27
      - NOTE: - In Windows you must point the environment variable
                BISON_SIMPLE to the location of the file bison.simple .
              - It was difficult to compile the Bison source to run on
                Windows and it was a long, long time ago in a far,
                far away place. It is completely up to the developer
                to build and install Bison.

     GCC 2.91.66 or MSDEVSTUDIO/VC 6
 */

/* LIMITATIONS:
     - SEE macro.l
 */

/*
 $Workfile: macro.y $
 $Revision: 38 $
 $Date: 2/06/02 6:34a $
 $Author: Chenot $
 $Modtime: 2/06/02 6:13a $
 $Log: /TINI/390 Assembler/source/macro/macro.y $
* 
* 38    2/06/02 6:34a Chenot
* 
* 37    2/06/02 5:54a Chenot
* 
* 36    2/06/02 5:51a Chenot
* initial support for *nested* conditional blocks
* 
* 35    2/05/02 6:32a Chenot
* now allow filenames that start with numeric characters
* 
* 34    1/30/02 6:12a Chenot
* added support for includes within conditional blocks
* 
* 33    12/14/01 7:15a Chenot
* 
* 32    12/13/01 1:27p Chenot
* 
* 31    11/14/01 6:06a Chenot
* 
* 30    11/14/01 5:37a Chenot
* 
* 28    11/02/01 6:29a Chenot
* 
* 27    11/02/01 6:27a Chenot
* 
* 25    10/16/01 2:03p Chenot
* 
* 24    10/16/01 1:06p Chenot
* 
* 23    5/15/01 11:41a Chenot
*
* 22    5/14/01 12:16p Chenot
*
* 21    5/14/01 12:13p Chenot
*
* 20    5/10/01 10:20a Chenot
*
* 19    5/07/01 9:18a Chenot
*
* 18    4/30/01 11:26a Chenot
*
* 17    4/26/01 9:36a Chenot
*
* 16    2/19/01 7:50a Chenot
*
* 15    2/19/01 7:42a Chenot
*
* 14    2/19/01 7:35a Chenot
*
* 13    2/17/01 5:31p Chenot
*
* 12    1/03/01 1:27p Chenot
*
* 11    1/03/01 1:22p Chenot
*
* 10    11/16/00 8:33a Chenot
*
* 9     9/11/00 5:34a Chenot
*
* 7     9/08/00 12:30p Chenot
*
* 5     9/08/00 9:15a Chenot
*
* 4     6/14/00 9:28a Chenot
*
* 3     5/20/00 9:11p Chenot
*
* 2     5/15/00 6:12a Chenot
*
* 41    5/03/00 2:29p Chenot
*
* 40    1/05/00 3:52p Tomc
*
* 39    12/15/99 8:50a Tomc
*
* 38    7/27/99 7:37a Tomc
*
* 37    7/12/99 1:35p Tomc
*
* 36    6/30/99 2:07p Tomc
*
* 35    6/30/99 1:30p Tomc
*
* 34    6/30/99 7:29a Tomc
*
* 33    5/21/99 2:13p Tomc
*
* 32    5/21/99 8:22a Tomc
*
* 31    5/20/99 12:04p Tomc
*
* 30    5/20/99 11:49a Tomc
*
* 29    5/19/99 1:54p Tomc
*
* 28    5/19/99 8:43a Tomc
*
* 27    5/17/99 11:08a Tomc
*
* 26    5/14/99 3:16p Tomc
*
* 25    5/04/99 8:46a Tomc
*
* 24    4/30/99 7:58a Tomc
*
* 23    4/29/99 3:38p Tomc
*
* 22    4/23/99 8:15a Tomc
* Works on a version of our source base
*
* 21    4/22/99 11:44a Tomc
*
* 20    4/22/99 9:41a Tomc
* Now iterative parser instead of recursive
*
* 19    4/21/99 3:24p Tomc
*
* 18    4/21/99 2:28p Tomc
*
* 17    4/21/99 12:51p Tomc
* parser works
*
* 16    4/20/99 3:46p Tomc
*
* 15    4/20/99 9:37a Tomc
*
* 14    4/20/99 9:31a Tomc
*
* 13    4/20/99 8:07a Tomc
*
* 12    4/19/99 3:34p Tomc
*
* 11    4/19/99 10:23a Tomc
*
* 10    4/16/99 3:20p Tomc
*
* 9     4/15/99 3:40p Tomc
*
* 8     4/15/99 5:27a Tomc
*/
/***********  Definitions and C pass-throughs  ***********/
%{
/***************************************************************************/
/*************************** begin yacc declarations ***********************/
/***************************************************************************/

#include "macro.h"

int yyparse (void);
int yyerror (char *mesg);
void InitConditionalStack(void);
void PushConditional(void);
void PopConditional(void);

extern  BOOL  InsertMacro();
extern  void  InitMacros();
extern  void  FreeMacros();
extern  BOOL  InsertEquate();
extern  void  InitEquates();
extern  void  FreeEquates();
extern  void  SetIncludePath(char *l_lpIncludePath);

#ifndef WIN32

#define SOLARIS
#ifdef SOLARIS // these values were pulled out of the air -> Find out the
               // true values NOW!!!
#define _MAX_PATH   255 /* max. length of full pathname */
#define _MAX_DRIVE  3   /* max. length of drive component */
#define _MAX_DIR    255 /* max. length of path component */
#define _MAX_FNAME  256 /* max. length of file name component */
#define _MAX_EXT    256 /* max. length of extension component */
#endif /* SOLARIS */
#endif /* !WIN32 */

#define WILDCARDS 0x01
#define EXTENSION 0x02
#define FILENAME  0x04
#define DIRECTORY 0x08
#define DRIVE     0x10

extern  FILE    *yyin,
                *g_lpOutFile,
                *g_lpTempOutFile;
extern  int     g_LineNumber;
extern  int     g_ExpressionValue;
extern  char    *yytext;
extern  char    g_LabelPrefix[80];
extern  char    g_TempString[260];
extern  BOOL    g_KillEnd;
extern  BOOL    g_InMacro;
extern  BOOL    g_InEquate;
extern  BOOL    g_HaveBitDigit;
extern  BOOL    g_InIncludeFile;
extern  int     g_NumberToResolve;
extern  MACRO   g_CurrentMacro;
extern  EQUATE  g_CurrentEquate;
extern  void    *g_lpVoidPtr;
extern  fpos_t  g_ExpressionPosition;

extern  LPREFERENCE_LIST  g_lpHoldReference;

int           g_BytesRead;
unsigned char g_TempBuff[1024];
BOOL          g_EndOfFile     = FALSE;
BOOL          g_BooleanIsTrue = FALSE;
BOOL          g_InExclusion   = FALSE;
BOOL          g_PICMode       = FALSE;
BOOL          g_GenerateDebugInfo  = FALSE;
CONDITIONAL_TABLE g_ConditionalStack;


extern  void        InitIncludeStack(void);
extern  BOOL        PushIncludeFile(char* p_lpFileName);
extern  BOOL        PopIncludeFile(void);
extern  const char  *GetCurrentFileName(void);
extern  FILE        *GetRootFile(void);

/*************************** end my yacc declarations **********************/
/***************************************************************************/

%}

/********************************** Tokens *********************************/

%token  TOKEN_IDENTIFIER
%token  TOKEN_MACRO
%token  TOKEN_ENDMACRO
%token  TOKEN_IMMEDIATE
%token  TOKEN_PARAM
%token  TOKEN_NEWLINE
%token  TOKEN_COMMA
%token  TOKEN_INCLUDE
%token  TOKEN_NUMBER
%token  TOKEN_EQUATE
%token  TOKEN_DOLLAR
%token  TOKEN_DOLLAR_EX
%token  TOKEN_INDIRECT
%token  TOKEN_CODE
%token  TOKEN_LOCAL
%token  TOKEN_END
%token  TOKEN_AND
%token  TOKEN_OR
%token  TOKEN_SHL
%token  TOKEN_SHR
%token  TOKEN_HIGH
%token  TOKEN_LOW
%token  TOKEN_NOT
%token  TOKEN_SEGMENT
%token  TOKEN_SEGMENT_TYPE
%token  TOKEN_SEGMENT_SELECT
%token  TOKEN_AT
%token  TOKEN_RSEG
%token  TOKEN_ORG
%token  TOKEN_BIT
%token  TOKEN_IF
%token  TOKEN_ELSE
%token  TOKEN_ENDIF
%token  TOKEN_MIN
%token  TOKEN_MAX

%left '+' '-'
%left '*' '/'
%left TOKEN_AND
%left TOKEN_OR
%left TOKEN_SHL
%left TOKEN_SHR

/******************************* Start Symbol ******************************/

%start Start  /* grammar starting symbol */

%%

/***************************** Grammar Section  ****************************/

/* Productions */                                      /* Symantic Actions */
                                                       /* After production */
                                                       /* is complete!     */
/* $$ */         /* $1,$2,... */

/* Don't forget - these code framents are executed after the production
                  is resolved ... think of it as a stack - when the
                  production is resolved, the production stack is popped
                  and the code is executed                               */

Start         :
                {
                  //printf("\nSuccess\n");
                  return 0;
                }
              | TOKEN_END
                {
                  //printf(" \nDone\n");
                  g_EndOfFile = TRUE;
                  return 0;
                }
              | Macro
                {
                  //printf("\nStart1\n");
                  return 0;
                }
              | TOKEN_NEWLINE
                {
                  //printf("\nStart2\n");
                  return 0;
                }
              | Equate
                {
                  //printf("\nStart3\n");
                  return 0;
                }
              | Conditional
                {
                  //printf("Conditional\n");
                  return 0;
                }
              | ConditionalElse
                {
                  //printf("ConditionalElse\n");
                  //return 0;
                }
              | ConditionalEndIf
                {
                  //printf("ConditionalEnd\n");
                  return 0;
                }
              | TOKEN_CODE
                {
                  //printf("\nStart4\n");
                  return 0;
                }
              | TOKEN_IDENTIFIER TOKEN_BIT
                {
                  //printf("\nStart5\n");
                  return 0;
                }
              | TOKEN_IDENTIFIER CodeEntry
                {
                  //printf("\nStart6\n");
                  return 0;
                }
              | TOKEN_IDENTIFIER CodeEntryNext
                {
                  //printf("\nStart7\n");
                  return 0;
                }
              | TOKEN_IDENTIFIER TOKEN_SEGMENT TOKEN_SEGMENT_TYPE
                {
                  //printf("\nStart8\n");
                  return 0;
                }
              | SegSelection
                {
                  //printf("\nStart9\n");
                  return 0;
                }
              | TOKEN_RSEG TOKEN_IDENTIFIER
                {
                  //printf("\nStart10\n");
                  return 0;
                }
              | TOKEN_ORG ProcessExpression
                {
                  //printf("\nStart11\n");
                  return 0;
                }
              ;

SegSelection  : TOKEN_SEGMENT_SELECT  SegAddress
                {}
              ;

SegAddress    :
              | TOKEN_AT ProcessExpression
                {}
              ;

Macro         : TOKEN_IDENTIFIER TOKEN_MACRO ParamList LocalList MacroBody TOKEN_ENDMACRO
                { /* store macro in table */
                  //printf("Got a macro ");
                  InsertMacro();
                }
              ;

Equate        : TOKEN_IDENTIFIER TOKEN_EQUATE Expression
                {/* store equate in table */
                  if(g_InEquate)
                  {
                    if(g_HaveBitDigit)
                    {
                      g_CurrentEquate.Value = g_NumberToResolve;
                      g_HaveBitDigit = FALSE;

                    }
                    else
                      g_CurrentEquate.Value = $3;

                    g_InEquate = FALSE;
                  }

                  //printf("Got an equate ");
                  InsertEquate();
                }
              | TOKEN_IDENTIFIER TOKEN_EQUATE TOKEN_IDENTIFIER
                {

                  g_CurrentEquate.Type = EQUATE_REFERENCE;
                  g_CurrentEquate.Reference = malloc(strlen(yytext)+1);

                  if(!g_CurrentEquate.Reference)
                    yyerror("Memory allocation error");

                  strcpy(g_CurrentEquate.Reference, yytext);
                  g_InEquate = FALSE;
                  //printf("Got an equate ");
                  InsertEquate();
                }
              ;

Conditional   : TOKEN_IF '(' Boolean ')'
                {
//                  printf("Conditional %s\n",
//                    g_BooleanIsTrue? "TRUE": "FALSE");
PushConditional();
/*
                  if(!g_BooleanIsTrue)
                  {
                    g_InExclusion = TRUE;
                    
                    //  essentially we are going to pipe
                    //  the code that is not to be included
                    //  to a NULL output stream or to be
                    //  more precise a temporary output
                    //  stream that will be deleted
                    //
                    // save the valid stream 
                    g_lpTempOutFile = g_lpOutFile;
                    // create a new, temporary stream
                    g_lpOutFile = tmpfile();
                  }
*/
                }
              ;

ConditionalElse : TOKEN_ELSE
                {
                  //printf("ConditionalElse \n");
                }
              ;

ConditionalEndIf : TOKEN_ENDIF
                {
//                  printf("ConditionalEnd \n");
PopConditional();
/*
                  if(g_InExclusion)
                  {
                    g_InExclusion = FALSE;
                    // close temporary stream 
                    fclose(g_lpOutFile);
                    // restore original stream 
                    g_lpOutFile = g_lpTempOutFile;
                  }
*/
                }
              ;

Boolean       : Expression '=' Expression
                {
//                  printf("Boolean( %d = %d)\n", $1,$3);

                  if($1 == $3)
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                }
              | Expression '!' '=' Expression
                {
                  //printf("Boolean( %d != %d )\n",$1,$4);

                  if($1 != $4)
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                }
              | Expression '>' Expression
                {
                  //printf("Boolean( %d > %d )\n",$1,$3);

                  if($1 > $3)
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                }
              | Expression '<' Expression
                {
                  //printf("Boolean( %d < %d )\n",$1,$3);

                  if($1 < $3)
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                }
              | Expression '>' '=' Expression
                {
                  //printf("Boolean( %d >= %d )\n",$1,$4);

                  if($1 >= $4)
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                }
              | Expression '<' '=' Expression
                {
                  //printf("Boolean( %d <= %d )\n",$1,$4);

                  if($1 <= $4)
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                }
              ;

LocalList     :
              | TOKEN_LOCAL  Locals
                {}
              ;

Locals        : TOKEN_IDENTIFIER TOKEN_COMMA Locals
                {}
              | TOKEN_IDENTIFIER TOKEN_NEWLINE
                {}
              ;

ParamList     : TOKEN_NEWLINE
                {}
              | Params
                {}
              ;

Params        : TOKEN_PARAM ParamEntry
                {}
              ;

ParamEntry    : TOKEN_IDENTIFIER ParamEntryNext
                { /*
                   * add a parameter to the list
                   * this is not called until
                   * all the params are parsed
                   * add parms in lex!!!
                   */
                }
              ;

ParamEntryNext: TOKEN_NEWLINE
                {}
              | ParamEntry
                {}
              ;

MacroBody     :
              | TOKEN_IDENTIFIER MacroEntry
                {}
              | TOKEN_NEWLINE    MacroBody
                {}
              ;

MacroEntry    :
              | CodeEntry MacroBody
                {}
              | CodeEntryNext MacroBody
                {}
              ;

ProcessExpression : Expression
                {
                  //printf("PROCESSING EXPRESSION ");
                  if(g_InMacro)
                  {
                    if(!g_PICMode)
                      sprintf(g_TempString, "0%Xh", $1);
                    else
                      sprintf(g_TempString, "h0%X", $1);

                    g_lpHoldReference->Reference.Pointer =
                                  malloc(strlen(g_TempString)+1);
                    strcpy((char *)(g_lpHoldReference->Reference.Pointer),
                           g_TempString);
                  }
                  else if(g_InEquate)
                  {
                    g_CurrentEquate.Value = $1;
                    g_InEquate = FALSE;
                  }
                  else
                  {
                    if(!g_InIncludeFile)
                    {
                      // we need to back up to the point where the
                      // expression started and insert the resolved
                      // number
                      fsetpos(g_lpOutFile, &g_ExpressionPosition);
                      g_BytesRead = fread(g_TempBuff, 1,
                                          sizeof(g_TempBuff), g_lpOutFile);
                      fsetpos(g_lpOutFile, &g_ExpressionPosition);

                      // this is a hack - it may not work for all cases
                      if((*g_TempBuff == ',') && (*yytext == ','))
                      {
                        if(!g_PICMode)
                          fprintf(g_lpOutFile, "0%Xh", $1);
                        else
                          fprintf(g_lpOutFile, "h0%X", $1);
                      }
                      else if((*g_TempBuff == '.') && (*yytext == ','))
                      {
                        if(!g_PICMode)
                          fprintf(g_lpOutFile, "0%Xh", $1);
                        else
                          fprintf(g_lpOutFile, "h0%X", $1);
                      }
                      else if((g_TempBuff[strlen(g_TempBuff)-1] == '\n') &&
                              (*yytext == '\n'))
                      {
                        if(!g_PICMode)
                          fprintf(g_lpOutFile, "0%Xh", $1);
                        else
                          fprintf(g_lpOutFile, "h0%X", $1);
                      }
                      else
                      {
                        while((*yytext == ' ') || (yytext == '\t'))
                          yytext++;

                        if((*g_TempBuff == ',') && (*yytext == ','))
                        {
                          if(!g_PICMode)
                            fprintf(g_lpOutFile, "0%Xh", $1);
                          else
                            fprintf(g_lpOutFile, "h0%X", $1);
                        }
                        else
                        {
                          if(!g_PICMode)
                            fprintf(g_lpOutFile, "0%Xh%s", $1, yytext);
                          else
                            fprintf(g_lpOutFile, "h0%X%s", $1, yytext);
                        }
                      }

                      fwrite(g_TempBuff, g_BytesRead, 1, g_lpOutFile);
                    }
                  }
                }
              | PicExpression
                {
                  fprintf(g_lpOutFile, "[h0%X]", $1);
                }
              ;
Expression    : Expression '+' Expression
                {$$ = $1 + $3}
              | Expression '-' Expression
                {$$ = $1 - $3}
              | Expression '*' Expression
                {$$ = $1 * $3}
              | Expression '/' Expression
                {
                  if($3 == 0)
                    yyerror("Attempt to divide by zero");
                  else
                    $$ = $1 / $3;
                }
              | Expression TOKEN_AND Expression
                {$$ = $1 & $3}
              | Expression TOKEN_OR Expression
                {$$ = $1 | $3}
              | Expression TOKEN_SHR Expression
                {$$ = $1 >> $3}
              | Expression TOKEN_SHL Expression
                {$$ = $1 << $3}
              | TOKEN_HIGH '(' Expression ')'
                {$$ = ($3 >> 8) & 0x0ff}
              | TOKEN_LOW '(' Expression ')'
                {$$ = $3 & 0x0ff}
              | TOKEN_NOT '(' Expression ')'
                {$$ = (~($3&0x0ffffff) & 0x0ffffff)}
              | TOKEN_MIN '(' Expression TOKEN_COMMA Expression ')'
                {$$ = ($3 < $5)? $3: $5}
              | TOKEN_MAX '(' Expression TOKEN_COMMA Expression ')'
                {$$ = ($3 > $5)? $3: $5}
              | '(' Expression ')'
                {
                  $$ = $2;
                }
              | TOKEN_NUMBER
                {
                  $$ = g_NumberToResolve;
                }
              ;
PicExpression : '[' Expression ']'
                {
                  if(g_PICMode)
                    $$ = $2;
                  else
                  {
                    sprintf(g_TempString,"Invalid Expression \"[%d]\"", $2);
                    yyerror(g_TempString);
                  }
                }
              ;
CodeEntry     : TOKEN_COMMA       CodeEntryNext
                {}
              | TOKEN_NEWLINE
                {}
              ;

CodeEntryNext : TOKEN_IDENTIFIER  CodeEntry
                {}
              | '/' TOKEN_IDENTIFIER  CodeEntry
                {/* slash */}
              | '/' ProcessExpression  CodeEntry
                {/* slash 2 */}
              | TOKEN_IMMEDIATE   CodeEntry
                {}
              | TOKEN_INDIRECT    CodeEntry
                {}
              | TOKEN_DOLLAR      CodeEntry
                {}
              | TOKEN_DOLLAR_EX   CodeEntry
                {}
              | ProcessExpression CodeEntry
                {}
              ;
%%

/***********  Program Section  ***********/
/***************************************************************************/
/****************************** yacc entry point ***************************/
/***************************************************************************/
void static   SplitPath(const char *pathP,
                        char *driveP,
                        char *dirP,
                        char *nameP,
                        char *extP);

void  CloseOutputFile(void);
char  *g_FileName;
char  g_TempOutputFileName[_MAX_DIR];
char  g_OutputFileName[_MAX_DIR];
char  *g_Tmp;
char  g_OutputBuff[32768];

#define VERSION_MAJOR 0
#define VERSION_MINOR 300
#define BUILD "$Revision: 38 $"
/*
*/
void PrintBanner()
{
  char  l_lpBuild[] = BUILD;
  char  *l_lpTemp;

  fprintf(stderr,
#ifdef WIN32
           ""\
           "ͻ\n"
          " Dallas Semiconductor DS80C390 Macro Preprocessor, Beta Version %d.%03d.%04u \n"
          ""\
          "ͼ\n"
#else
          "+------------------------------------------------------------------"\
          "---------+\n"
          "| Dallas Semiconductor DS80C390 Macro Preprocessor, Beta Version %d.%03d.%04u |\n"
          "+------------------------------------------------------------------"\
          "---------+\n"
#endif
          "Last build %s at %s\n\n",
          VERSION_MAJOR,
          VERSION_MINOR,
          strtol(strtok(l_lpBuild,"evision: $R"), &l_lpTemp, 10),
          __DATE__,
          __TIME__);

}
/*
*/
void Usage(int p_ErrorCode)
{
  fprintf(stderr, "Usage:\tmacro [options] <input file>\n");
  fprintf(stderr, "\toptions:\n");
  fprintf(stderr, "\t-q\t\t\tquiet mode\n");
  fprintf(stderr, "\t-p\t\t\tUC03 mode\n");
  //fprintf(stderr, "\t-g\t\t\tgenerate line info\n"); // for debug use
  fprintf(stderr, "\t-e-\t\t\tstrip \"end\" statement\n");
  fprintf(stderr, "\t-I<Include Path>\toptional include file directory\n");
  fprintf(stderr, "\n");
  exit(p_ErrorCode);
}
/*
*/
int main(int argc, char *argv[])
{
  char  l_Drive[_MAX_DRIVE];
  char  l_Dir[_MAX_DIR];
  char  l_Name[_MAX_FNAME];
  char  l_Ext[_MAX_EXT];
  char  l_QuietMode = 0;
  int   l_Strlen;
  int   l_RetVal;
  int   l_Count = 0;
  int   i;
  char  *l_lpFilename = NULL;
  char  *l_lpIncludePath = NULL;

  if(argc < 2)
  {
    PrintBanner();
    Usage(0);
  }

  for(i = 1; i < argc; i++)
  {
    if(argv[i][0] != '-')
    {
      l_lpFilename = argv[i];
    }
    else
    {
      if(!strcmp(argv[i], "-E-"))
        g_KillEnd = TRUE;
      else if(!strcmp(argv[i], "-e-"))
        g_KillEnd = TRUE;
      else if(argv[i][1] == 'q')
        l_QuietMode = 1;
      else if(argv[i][1] == 'p')
        g_PICMode = 1;
      else if(argv[i][1] == 'g')
        g_GenerateDebugInfo = 1;
      else if(argv[i][1] == 'I')
      {
        l_lpIncludePath = argv[i]+2;
        SetIncludePath(l_lpIncludePath);
      }
      else
      {
        PrintBanner();
        fprintf(stderr, "Unrecognized switch \"%s\"\n\n", argv[i]);
        Usage(1);
      }
    }
  }

  SplitPath(l_lpFilename,
            l_Drive,
            l_Dir,
            l_Name,
            l_Ext);
  l_Strlen  = strlen(l_Name);
  memcpy(g_LabelPrefix, l_Name, l_Strlen);

  strcpy(g_OutputFileName, l_Name);
  strcat(g_OutputFileName, ".mpp");

  // this function reuses the filename buffer
  g_Tmp = tmpnam(NULL);
  // make a copy to prevent scroggage
  strcpy(g_TempOutputFileName, g_Tmp);

  remove(g_OutputFileName);

  if(!(g_lpOutFile = fopen(g_TempOutputFileName,"w+")))
  {
    PrintBanner();
    fprintf(stderr, "Unable to open the file %s\n", l_Dir);
    return 1;
  }

  if(!l_QuietMode)
    PrintBanner();

  setvbuf(g_lpOutFile, g_OutputBuff, _IOFBF, sizeof(g_OutputBuff));

  if(g_PICMode)
  {
    if(g_GenerateDebugInfo)
      fprintf(g_lpOutFile,";BEGIN_MODULE(%s)\n", l_lpFilename);
  }
  else
    fprintf(g_lpOutFile,"$BEGIN_MODULE(%s)\n", l_Name);

  if(!l_QuietMode)
  {
    fprintf(stderr,"Parsing %s...\n", l_lpFilename);

    if(g_PICMode)
      fprintf(stderr, "Using PIC syntax\n");

    if(g_KillEnd)
      fprintf(stderr, "Stripping END statement\n");

    if(g_GenerateDebugInfo)
      fprintf(stderr, "Generating debug line information\n");

    if(l_lpIncludePath)
      fprintf(stderr, "Adding include path \"%s\"\n", l_lpIncludePath);
  }

  g_FileName = l_lpFilename;
  InitMacros();
  InitEquates();
  InitIncludeStack();
  InitConditionalStack();

  if(!PushIncludeFile(g_FileName))
  {
    //printf("Error, Unable to open %s",l_lpFilename);
    return 2;
  }

//yydebug=1;

  do
  {
    if((l_RetVal = yyparse()))    /* parse a statement   */
    {
      break;
    }
/*
    switch((l_Count++)%4)
    {
      case 0:
        fprintf(stderr,"|\r");
      break;

      case 1:
        fprintf(stderr,"/\r");
      break;

      case 2:
        fprintf(stderr,"-\r");
      break;

      case 3:
        fprintf(stderr,"\\\r");
      break;
    }

    l_Count &= 3;
*/
  } while (!g_EndOfFile);

  fflush(stdout);

  if(l_RetVal)
    fprintf(stderr, " \nParser terminated with error\n");
  else
  {
    if(!l_QuietMode)
      fprintf(stderr, " \nParser terminated without error\n");
  }

  fflush(stderr);
  CloseOutputFile();
  FreeMacros();
  FreeEquates();
  remove(g_TempOutputFileName);

  return 0;
}
/***************************************************************************/
int yyerror (char *mesg)
{
  char *l_CurrentFileName = GetCurrentFileName();
  printf("\n%s: %s\n%*cLine %d. Last token read was \"%s\"\n",
         l_CurrentFileName,
         mesg, 
         strlen(l_CurrentFileName)+2,' ',
         g_LineNumber,
         yytext? yytext: "");

  CloseOutputFile();
  FreeMacros();
  FreeEquates();
  remove(g_OutputFileName);
  remove(g_TempOutputFileName);

  exit(1);
//  return 0;
}/* yyerror */
/***************************************************************************/
int yywrap ()
{
  if(PopIncludeFile())
      return 0;
/*
  if(g_lpOutFile)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }
*/
  g_EndOfFile = TRUE;
  FreeMacros();
  FreeEquates();
  remove(g_TempOutputFileName);

  return 0;
}/* yywrap */
/***************************************************************************/
/*
 */
void InitConditionalStack()
{
  memset(&g_ConditionalStack, 0, sizeof(g_ConditionalStack));
}
/***************************************************************************/
/*
 */
void PushConditional()
{
  if((g_ConditionalStack.StackPointer+1) == MAX_CONDITIONAL)
    yyerror("Maximum conditional stack exceeded");

  g_ConditionalStack.List[g_ConditionalStack.StackPointer].InExclusion = 
                                                             g_InExclusion;
  g_ConditionalStack.List[g_ConditionalStack.StackPointer].LineNumber = 
                                                          g_LineNumber;
  strcpy(g_ConditionalStack.List[g_ConditionalStack.StackPointer++].FileName,
         GetCurrentFileName());

  if(!g_InExclusion)
  {
    if(!g_BooleanIsTrue)
    {
      g_InExclusion = TRUE;
      /*
       * essentially we are going to pipe
       * the code that is not to be included
       * to a NULL output stream or to be
       * more precise a temporary output
       * stream that will be deleted
       */
      /* save the valid stream */
      g_lpTempOutFile = g_lpOutFile;
      /* create a new, temporary stream */
      g_lpOutFile = tmpfile();
    }
  }
}
/***************************************************************************/
/*
 */
void PopConditional()
{
  if((--g_ConditionalStack.StackPointer) < 0)
    yyerror("Found \"ENDIF with no matching \"IF\"");

  if(!g_ConditionalStack.List[g_ConditionalStack.StackPointer].InExclusion & 
     g_InExclusion)
  {
    g_InExclusion = FALSE;
    /* close temporary stream */
    fclose(g_lpOutFile);
    /* restore original stream */
    g_lpOutFile = g_lpTempOutFile;
  }

  g_InExclusion = 
     g_ConditionalStack.List[g_ConditionalStack.StackPointer].InExclusion;
}
/***************************************************************************/
/*
 * fsetpos doesn't resize the file and extra characters remain at the end of
 * the file. This function resizes the file in an ANSI C compatible fashion.
 */
#ifdef WIN32
#include<io.h>
void  CloseOutputFile(void)
{
  _chsize(fileno(g_lpOutFile),ftell(g_lpOutFile));
  fclose(g_lpOutFile);
  rename(g_TempOutputFileName, g_OutputFileName);
}
#else
void  CloseOutputFile(void)
{
  int     filelength(int);
  FILE   *l_lpTempFile;
  long    l_FilePos;
  char    *l_lpFileName = tmpnam(NULL);
  char    *l_lpBuff = NULL;
  size_t  l_BytesRead;
  long    l_Size = ftell(g_lpOutFile);

  if(!g_lpOutFile)
    return;

  if(!l_lpFileName)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }

  l_FilePos = ftell(g_lpOutFile);
  rewind(g_lpOutFile);
  l_lpTempFile = fopen(l_lpFileName,"w+");

  if(!l_lpFileName)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }

  if(!l_lpBuff)
    l_lpBuff = malloc(l_Size);

  if(!l_lpBuff)
  {
    l_Size = 32768;
    l_lpBuff = malloc(l_Size);
  }

  if(l_lpBuff)
  {

    while((long)(ftell(l_lpTempFile) + l_Size) < l_FilePos)
    {
      l_BytesRead = fread(l_lpBuff, 1,  l_Size,  g_lpOutFile);
      fwrite(l_lpBuff,  l_BytesRead,  1,  l_lpTempFile);
    }

    if((long)ftell(l_lpTempFile) < l_FilePos)
    {
      l_BytesRead = fread(l_lpBuff, 1,  l_Size,  g_lpOutFile);
      fwrite(l_lpBuff,  l_BytesRead,  1,  l_lpTempFile);
    }
/*
    while(fread(l_lpBuff, 1,  1,  g_lpOutFile))
    {
      fwrite(l_lpBuff,  1,  1,  l_lpTempFile);

      if(l_FilePos == ftell(l_lpTempFile))
      {
        break;
      }
    }
*/
    fclose(l_lpTempFile);
    fclose(g_lpOutFile);

    g_lpOutFile = fopen(g_OutputFileName,"w+");
    l_lpTempFile = fopen(l_lpFileName,"r");

    while((l_BytesRead = fread(l_lpBuff, 1, l_Size, l_lpTempFile)))
      fwrite(l_lpBuff, l_BytesRead, 1, g_lpOutFile);

    free(l_lpBuff);
  }

  fclose(l_lpTempFile);
  fclose(g_lpOutFile);
  remove(l_lpFileName);
  g_lpOutFile = NULL;
}
#endif
/***************************************************************************/
static void CopyIt(char *dst, const char *src, unsigned maxlen)/* Modified Borland C++ 3.1 code */
{                  /* for portability */
  if(dst)
  {
    if(strlen(src) >= maxlen)
    {
      strncpy(dst, src, maxlen);
      dst[maxlen] = 0;
    }
    else
      strcpy(dst, src);
  }
}
/***************************************************************************/
static int DotFound(char *pB)/* Modified Borland C++ 3.1 code */
{                            /* for portability */
  if(*(pB-1) == '.')
    pB--;

  switch (*--pB)
  {
    case ':'  :
      if(*(pB-2) != '\0')
        break;
    case '/'  :
    case '\\' :
    case '\0' :
    return 1;
  }

  return 0;
}
/***************************************************************************/
int FnSplit(const char *pathP,/* Modified Borland C++ 3.1 code */
            char *driveP,     /* for portability */
            char *dirP,
            char *nameP,
            char *extP)
{
  char   *pB;
  int    Wrk;
  int     Ret;
  char buf[_MAX_PATH+2];

  /*
    Set all strings to default value zero
  */
  Ret = 0;

  if(driveP)
    *driveP = 0;

  if(dirP)
    *dirP = 0;

  if(nameP)
    *nameP = 0;

  if(extP)
    *extP = 0;

  /*
    Copy filename into template up to _MAX_PATH characters
  */
  pB = buf;

  while (*pathP == ' ')
    pathP++;

  if((Wrk = strlen(pathP)) > _MAX_PATH)
    Wrk = _MAX_PATH;

  *pB++ = 0;
  strncpy(pB, pathP, Wrk);
  *(pB += Wrk) = 0;

  /*
    Split the filename and fill corresponding nonzero pointers
  */
  Wrk = 0;

  for (;;)
  {
    switch (*--pB)
    {
      case '.'  :
        if(!Wrk && (*(pB+1) == '\0'))
          Wrk = DotFound(pB);

        if((!Wrk) && ((Ret & EXTENSION) == 0))
        {
          Ret |= EXTENSION;
          CopyIt(extP, pB, _MAX_EXT - 1);
          *pB = 0;
        }
      continue;

      case ':'  :
        if(pB != &buf[2])
          continue;

      case '\0' :
        if(Wrk)
        {
          if(*++pB)
            Ret |= DIRECTORY;

          CopyIt(dirP, pB, _MAX_DIR - 1);
          *pB-- = 0;
          break;
        }

      case '/'  :
      case '\\' :
        if (!Wrk)
        {
          Wrk++;

          if (*++pB)
            Ret |= FILENAME;

          CopyIt(nameP, pB, _MAX_FNAME - 1);
          *pB-- = 0;

          if (*pB == 0 || (*pB == ':' && pB == &buf[2]))
            break;
        }
      continue;

      case '*'  :
      case '?'  :
        if (!Wrk)
          Ret |= WILDCARDS;

      default :
      continue;
    }
    break;
  }

  if(*pB == ':')
  {
    if(buf[1])
      Ret |= DRIVE;

    CopyIt(driveP, &buf[1], _MAX_DRIVE - 1);
  }

  return (Ret);
}
/***************************************************************************/
void static SplitPath(const char *pathP,/* Modified Borland C++ 3.1 code */
                      char *driveP,     /* for portability */
                      char *dirP,
                      char *nameP,
                      char *extP)
{
  (void)FnSplit(pathP,driveP,dirP,nameP,extP);
}

/***************************************************************************/
/***************************** end my yacc source **************************/
/***************************************************************************/
